org.apache.hc.client5.http.io

## Interface HttpClientConnectionOperator

All Known Implementing Classes:
  DefaultHttpClientConnectionOperator

    @Contract(threading=STATELESS)
    @Internal
    public interface HttpClientConnectionOperator

Connection operator that performs connection connect and upgrade operations.

Since:
  4.4

### Method Summary

Methods
`void` `connect(ManagedHttpClientConnection conn, org.apache.hc.core5.http.HttpHost host, InetSocketAddress localAddress, org.apache.hc.core5.util.TimeValue connectTimeout, org.apache.hc.core5.http.io.SocketConfig socketConfig, org.apache.hc.core5.http.protocol.HttpContext context)` Connect the given managed connection to the remote endpoint.
`void` `upgrade(ManagedHttpClientConnection conn, org.apache.hc.core5.http.HttpHost host, org.apache.hc.core5.http.protocol.HttpContext context)` Upgrades transport security of the given managed connection by using the TLS security protocol.

### Method Detail

#### connect

    void connect(ManagedHttpClientConnection conn,
               org.apache.hc.core5.http.HttpHost host,
               InetSocketAddress localAddress,
               org.apache.hc.core5.util.TimeValue connectTimeout,
               org.apache.hc.core5.http.io.SocketConfig socketConfig,
               org.apache.hc.core5.http.protocol.HttpContext context)
                 throws IOException

Connect the given managed connection to the remote endpoint.

Parameters:
  `conn` - the managed connection.
  `host` - the address of the opposite endpoint.
  `localAddress` - the address of the local endpoint.
  `connectTimeout` - the timeout of the connect operation.
  `socketConfig` - the socket configuration.
  `context` - the execution context.
Throws:
  `IOException`

#### upgrade

    void upgrade(ManagedHttpClientConnection conn,
               org.apache.hc.core5.http.HttpHost host,
               org.apache.hc.core5.http.protocol.HttpContext context)
                 throws IOException

Upgrades transport security of the given managed connection by using the TLS security protocol.

Parameters:
  `conn` - the managed connection.
  `host` - the address of the opposite endpoint with TLS security.
  `context` - the execution context.
Throws:
  `IOException`